/* MERGE SORT-veoma efikasan (n*logn) iako izgleda da nije zbog komplikovanijeg algoritma; ovdje je kod za sort sa 
              sablonima i rekurzivno definisan. */
#include <iostream>
using namespace std;
   
   template <class T>
        void MergeSort(T niz[], T  pomocni_niz[], int duzina)
      {
            sortiraj(niz, pomocni_niz, 0, duzina - 1);
      }
    
    template <class T> 
        void sortiraj(T  niz[], T pomocni_niz[], int lijevo, int desno)// lijevo je indeks elementa od kojeg pocinje sortiranje  a desno
      {                                                                // indeks elementa do kojeg se se sortira najcesce su to 0 i duzina-1
            int sredina;

             if (desno > lijevo)
           {
                     sredina = (desno + lijevo) / 2;
                     sortiraj(niz, pomocni_niz, lijevo, sredina);      // niz se uzastopno dijeli na dva dijela koja se kasnije spajaju
                     sortiraj(niz, pomocni_niz, (sredina+1), desno);

                     merge(niz, pomocni_niz, lijevo, (sredina+1), desno); //spajanje
           }
      }
    
    template <class T> 
        void merge(T niz[], T pomocni_niz[], int lijevo, int sredina, int desno)
      {
            int  lijevi_kraj, br_elemenata, indeks ;

                     lijevi_kraj = (sredina - 1);
                     indeks = lijevo;
                     br_elemenata = (desno - lijevo + 1);

              while ((lijevo <= lijevi_kraj) && (sredina <= desno))
           {
               if (niz[lijevo] <= niz[sredina])
             {
                     pomocni_niz[indeks] = niz[lijevo];
                     indeks += 1;
                     lijevo += 1;
             }
                 else
               {
                     pomocni_niz[indeks] = niz[sredina];
                     indeks += 1;
                     sredina += 1;
               }
           }

              while (lijevo <= lijevi_kraj)
           {
                     pomocni_niz[indeks] = niz[lijevo];
                     lijevo += 1;
                     indeks += 1;
           }
              
              while (sredina <= desno)
           {
                     pomocni_niz[indeks] = niz[sredina];
                     sredina += 1;
                     indeks += 1;
           }
              
              for ( int i=0; i < br_elemenata; i++)
           {
                     niz[desno] = pomocni_niz[desno];
                     desno -= 1;
           }
      }


  int main(){
      
      char niz1[5] = {'o', 'e', 'i', 'u', 'a'};
      char pomocni_niz1[5];

      int niz2[5] = {34, 456, 105, 64, 9};
      int pomocni_niz2[5];

      double niz3[5]={2.5, 7.4, 0.12, 3.33, 1.05};
      double pomocni_niz3[5];
       
      MergeSort(niz1, pomocni_niz1, 5);
      MergeSort(niz2, pomocni_niz2, 5);
      MergeSort(niz3, pomocni_niz3, 5);

	   
      for (int i = 0; i < 5; i++)
        cout << niz1[i] << " ";
   	  
      cout << endl;

      for (int i = 0; i < 5; i++)
        cout << niz2[i] << " ";
   	  
      cout << endl;
    
      for (int i = 0; i < 5; i++)
        cout << niz3[i] << " ";
   	  
      cout << endl;
    
      cout << endl;            
      system("pause");
      return 0;
         
}
